package com.govmade.modules.system.service;


import java.util.List;
import java.util.Map;
import java.util.Set;

import com.baomidou.mybatisplus.extension.service.IService;
import com.govmade.common.utils.PageTreeUtils;
import com.govmade.modules.system.entity.MenuEntity;

/**
 * 系统管理 - 菜单设置
 * 
 * @author Fred
 * @email fangtaosh@qq.com
 * @date 2018年8月3日
 */
public interface MenuService extends IService<MenuEntity> {

	/**
	 * 菜单树形结构
	 */
	PageTreeUtils queryPage(Map<String, Object> params);
	
	/**
	 * 保存或修改菜单
	 */
	void save(MenuEntity menu);
	
	/**
	 * 检测是否重名
	 */
	Integer checkMenu(String name);
	
	MenuEntity queryById(Long id);
	
	/**
	 * 删除菜单
	 */
	void deleteBatch(Set<Long> ids);
	
	/**
	 * 菜单列表
	 */
	List<MenuEntity> queryMenuList();
}
